//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Fri Jan  5 16:52:01 2018 by ROOT version 6.08/06
// from TTree td/decays
// found on file: ../RunOutput.root
//////////////////////////////////////////////////////////

#ifndef Analysis_h
#define Analysis_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include "TLorentzVector.h"
#include "fastjet/ClusterSequence.hh"

using namespace fastjet;
using namespace std;
// Header file for the classes stored in the TTree if any.

#include <vector>
#include <iostream>

class Analysis {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

// Fixed size dimensions of array or collections stored in the TTree if any.

   // Declaration of leaf types
   int _nev;
   int _Ntot, _Nhyd, _Npyt, _Njet, _Nbcol, _Npart;
   float _Bgen, _Sigin, _Sigjet;
   vector<float> _Px, _Py, _Pz, _E;
   vector<float> _X, _Y, _Z, _T;
   vector<int> _pdg;
   vector<int> _Mpdg;
   vector<int> _type;
   vector<int> _status;
   vector<int> _Index;
   vector<int> _MotherIndex;
   vector<int> _NDaughters;
   vector<int> _FirstDaughterIndex;
   vector<int> _LastDaughterIndex;
   vector<int> _final;
   vector<TLorentzVector> _jets;

   // Declaration of leaf types
   int *nev;
   int *Ntot, *Nhyd, *Npyt, *Njet, *Nbcol, *Npart;
   float *Bgen, *Sigin, *Sigjet;
   vector<float> *Px, *Py, *Pz, *E;
   vector<float> *X, *Y, *Z, *T;
   vector<int> *pdg;
   vector<int> *Mpdg;
   vector<int> *type;
   vector<int> *pythiaStatus;
   vector<int> *Index;
   vector<int> *MotherIndex;
   vector<int> *NDaughters;
   vector<int> *FirstDaughterIndex;
   vector<int> *LastDaughterIndex;
   vector<int> *final;

   // List of branches
   TBranch        *b_nev;   //!
   TBranch        *b_Bgen;   //!
   TBranch        *b_Sigin;   //!
   TBranch        *b_Sigjet;   //!
   TBranch        *b_Ntot;   //!
   TBranch        *b_Nhyd;   //!
   TBranch        *b_Npyt;   //!
   TBranch        *b_Njet;   //!
   TBranch        *b_Nbcol;   //!
   TBranch        *b_Npart;   //!
   TBranch        *b_Px;   //!
   TBranch        *b_Py;   //!
   TBranch        *b_Pz;   //!
   TBranch        *b_E;   //!
   TBranch        *b_X;   //!
   TBranch        *b_Y;   //!
   TBranch        *b_Z;   //!
   TBranch        *b_T;   //!
   TBranch        *b_pdg;   //!
   TBranch        *b_Mpdg;   //!
   TBranch        *b_type;   //!
   TBranch        *b_pythiaStatus;   //!
   TBranch        *b_Index;   //!
   TBranch        *b_MotherIndex;   //!
   TBranch        *b_NDaughters;   //!
   TBranch        *b_FirstDaughterIndex;   //!
   TBranch        *b_LastDaughterIndex;   //!
   TBranch        *b_final;   //!

   Analysis(TString file="", TString outputfile="");
   virtual ~Analysis();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
   virtual void     Init(TTree *tree);
   virtual void     Loop();
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);
   virtual void     ReadEvent(int jentry);

   TString output_name;
};

#endif

#ifdef Analysis_cxx

void Analysis::ReadEvent(int jentry) {
  LoadTree(jentry);
  fChain->GetEntry(jentry);
  _nev = (*nev);
  _Ntot = (*Ntot); 
  _Nhyd = (*Nhyd);
  _Npyt = (*Npyt); 
  _Njet = (*Njet); 
  _Nbcol = (*Nbcol);
  _Npart = (*Npart);
  _Bgen = (*Bgen);
  _Sigin = (*Sigin);
  _Sigjet = (*Sigjet);
  _Px = (*Px);
  _Py = (*Py);
  _Pz = (*Pz);
  _E  = (*E);
  _X = (*X);
  _Y = (*Y);
  _Z = (*Z);
  _T = (*T);
  _pdg = (*pdg);
  _Mpdg = (*Mpdg);
  _type = (*type);
  _status = (*pythiaStatus);
  _Index = (*Index);
  _MotherIndex = (*MotherIndex);
  _NDaughters = (*NDaughters);
  _FirstDaughterIndex = (*FirstDaughterIndex);
  _LastDaughterIndex = (*LastDaughterIndex);
  _final = (*final);
  TLorentzVector test;
  vector<fastjet::PseudoJet> input_particles;
  for(int i=0; i<_pdg.size(); i++) {
    if (_status[i]==1) {
      test.SetPxPyPzE(_Px[i], _Py[i], _Pz[i], _E[i]);
      input_particles.push_back( fastjet::PseudoJet(test.Px(), test.Py(), test.Pz(), test.E()) );
    }
  }
  // Let us use the kT algorithm with R=0.4
   double R = 0.4;
   fastjet::JetAlgorithm jet_alg = fastjet::kt_algorithm;
   fastjet::RecombinationScheme recomb_scheme=fastjet::E_scheme;
   fastjet::JetDefinition jet_def(jet_alg, R, recomb_scheme);
  // cluster the objects
   fastjet::ClusterSequence cs(input_particles, jet_def);

  // Then we extract the jets
   double ptmin = 1.0;
   vector<fastjet::PseudoJet> jets = sorted_by_E(cs.inclusive_jets(ptmin));
   for(unsigned int i=0; i<jets.size();i++) {
     TLorentzVector pJet;
     pJet.SetPxPyPzE( jets[i].px(), jets[i].py(), jets[i].pz(), jets[i].E());
     _jets.push_back(pJet);
   }
}

Analysis::Analysis(TString file, TString outputfile) : fChain(0) 
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
  TTree * tree=0;
  if (file.Sizeof()==0) file = "RunOutput.root";
  cout << "Reading events from " << file << endl;
  TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("RunOutput.root");
  if (!f || !f->IsOpen()) {
    f = new TFile(file);
  }
  f->GetObject("Analysis",tree);
  Init(tree);

  output_name=outputfile;
}

Analysis::~Analysis()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t Analysis::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t Analysis::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->GetTreeNumber() != fCurrent) {
      fCurrent = fChain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void Analysis::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set object pointers
   nev = 0;
   Ntot = 0;
   Nhyd = 0;
   Npyt = 0;
   Njet = 0;
   Nbcol = 0;
   Npart = 0;
   Bgen = 0;
   Sigin = 0;
   Sigjet = 0;
   Px = 0;
   Py = 0;
   Pz = 0;
   E = 0;
   X = 0;
   Y = 0;
   Z = 0;
   T = 0;
   pdg = 0;
   Mpdg = 0;
   type = 0;
   pythiaStatus = 0;
   Index = 0;
   MotherIndex = 0;
   NDaughters = 0;
   FirstDaughterIndex = 0;
   LastDaughterIndex = 0;
   final = 0;
   
   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("nev", &nev, &b_nev);
   fChain->SetBranchAddress("Bgen", &Bgen, &b_Bgen);
   fChain->SetBranchAddress("Sigin", &Sigin, &b_Sigin);
   fChain->SetBranchAddress("Sigjet", &Sigjet, &b_Sigjet);
   fChain->SetBranchAddress("Ntot", &Ntot, &b_Ntot);
   fChain->SetBranchAddress("Nhyd", &Nhyd, &b_Nhyd);
   fChain->SetBranchAddress("Npyt", &Npyt, &b_Npyt);
   fChain->SetBranchAddress("Njet", &Njet, &b_Njet);
   fChain->SetBranchAddress("Nbcol", &Nbcol, &b_Nbcol);
   fChain->SetBranchAddress("Npart", &Npart, &b_Npart);
   fChain->SetBranchAddress("Px", Px, &b_Px);
   fChain->SetBranchAddress("Py", Py, &b_Py);
   fChain->SetBranchAddress("Pz", Pz, &b_Pz);
   fChain->SetBranchAddress("E", E, &b_E);
   fChain->SetBranchAddress("X", X, &b_X);
   fChain->SetBranchAddress("Y", Y, &b_Y);
   fChain->SetBranchAddress("Z", Z, &b_Z);
   fChain->SetBranchAddress("T", T, &b_T);
   fChain->SetBranchAddress("pdg", pdg, &b_pdg);
   fChain->SetBranchAddress("Mpdg", Mpdg, &b_Mpdg);
   fChain->SetBranchAddress("type", type, &b_type);
   fChain->SetBranchAddress("pythiaStatus", pythiaStatus, &b_pythiaStatus);
   fChain->SetBranchAddress("Index", Index, &b_Index);
   fChain->SetBranchAddress("MotherIndex", MotherIndex, &b_MotherIndex);
   fChain->SetBranchAddress("NDaughters", NDaughters, &b_NDaughters);
   fChain->SetBranchAddress("FirstDaughterIndex", FirstDaughterIndex, &b_FirstDaughterIndex);
   fChain->SetBranchAddress("LastDaughterIndex", LastDaughterIndex, &b_LastDaughterIndex);
   fChain->SetBranchAddress("final", final, &b_final);
   Notify();
}

Bool_t Analysis::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

void Analysis::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t Analysis::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}

int main(int argc, char* argv[]) {
  TString file = "RunOutput.root";
  if(argc>1) file = argv[1];

  TString outputfile = "Output_Histo.root";
  if(argc>2) outputfile = argv[2];

  Analysis *a = new Analysis(file, outputfile);
  a->Loop();
  delete a;
}
#endif // #ifdef Analysis_cxx
